/// Functions for performing cryptographic operations on the main data structures.

use super::*;

/// Errors that can occur during cryptographic operations.
pub(crate) enum Error {
    NoReadCap
}

type Result<T> = std::result::Result<T, Error>;

fn decrypt<T>(_ciphertext: &Cryptotext<T>, _key: &Key) -> Result<T> {
    unimplemented!();
}

fn decrypt_in_place(_ciphertext: &mut [u8], _key: &Key) -> Result<()> {
    unimplemented!();
}

#[allow(dead_code)]
pub(crate) fn decrypt_block(
    versioned_block: &mut VersionedBlock, principal: &Principal, key: &Key
) -> Result<()> {
    let VersionedBlock::V0(block) = versioned_block;
    let body = match &mut block.body {
        Cryptotext::Plain(_) => return Ok(()),
        Cryptotext::Cipher(body) => body
    };
    let read_cap = block.read_caps.get(principal).ok_or(Error::NoReadCap)?;
    let block_key = decrypt(read_cap, key)?;
    decrypt_in_place(body, &block_key)?;
    Ok(())
}

#[cfg(test)]
mod tests {
}